#include "TimeManager.h"
#include "UciParser.h"

void TimeManager::startInfiniteSearch(void)
{
}


void TimeManager::stop(void)
{
    shouldStop = true;
}


void TimeManager::join(void)
{
    searchThread.join();
}


void TimeManager::startSearch(void)
{
    startInfiniteSearch();
}


bool TimeManager::isRunning(void) const
{
    return running;
}

chessy::Move TimeManager::getBestMove(void) const
{
    return bestMove;
}


void FixedSearchTimer::startSearch(void)
{
    startPoint = std::chrono::steady_clock::now();
    TimeManager::searchThread = 
        std::thread{ &FixedSearchTimer::search, this };
    /*using namespace std;
    using namespace chrono;
    startPoint = steady_clock::now();
    search();*/
}


void FixedSearchTimer::search(void)
{
    using namespace std;
    using namespace chrono;
    int depth = 2;

    auto timeCheck = [&]()
    {
        auto now = steady_clock::now();
        if ((now - startPoint) > thinkTime)
            shouldStop = true;
        if (shouldStop)
            return true;
        else
            return false;
    };

    while (true) {
        chessy::MoveValue value;
        chessy::Move best;
        tie(best, value) = chessy::miniMax(game, depth, timeCheck);
        uci.write("info", "depth", depth, "currmove", best.asString(), "score", "cp", value);
        if (best.destination != best.origin)
            bestMove = best;
        if (timeCheck())
            break;
        ++depth;
    }
    uci.write("bestmove", bestMove.asString());
}

